// C Source File
//#########################################################################
// 
//       Pathfinding Demo   - first version
//      
//          Main Program
//   
//         Created 18/01/2003; 21:14:28
//
//           By David Coz  
//
//       Coz.hubert@infonie.fr
//
//  You must add extgraph.h and extgraph.a in your project
//
//##########################################################################



#define USE_TI89              // Compile for TI-89
//#define USE_TI92PLUS          // Compile for TI-92 Plus
//#define USE_V200              // Compile for V200

#define OPTIMIZE_ROM_CALLS // Use ROM Call Optimization

#define MIN_AMS 100           // Compile for AMS 1.00 or higher

#define SAVE_SCREEN           // Save/Restore LCD Contents

#include <tigcclib.h>         // Include All Header Files
#include "extgraph.h"

#define ABS(a)  (((a)<0) ? -(a): (a))
#define SGN(a)  (((a)<0) ? -1 : 1)
#define DISP 0
#define MAP_X 20
#define MAP_Y 12

#define SEARCHING    0
#define PATH_FOUND   1
#define NO_PATH      2

#define WALL      3
#define WATER     2
#define GRASS     1 


#define CLOSED    2
#define OPEN      3
#define UNCHECKED 0

#define ESC     264

#define MAX_X    18
#define MIN_X     1
#define MAX_Y    10
#define MIN_Y     1

#define MAGIC 50584
#define VERSION 100


//***********  Clock Definition ,thanx to Thomas Nussbaumer. *****************

volatile long int mseconds = 0;
volatile long int mseconds2 = 0;
long int key_time;
volatile long int mseconds50 = 0; 
volatile int seconds    = 0; 
volatile int minutes    = 0; 
volatile int resettime  = 1; 
volatile int running  =1;


INT_HANDLER oldint5 = NULL;
DEFINE_INT_HANDLER (myint5handler) {
       if (resettime) {
       mseconds50=mseconds2=mseconds=seconds=minutes=resettime=0;
    }
    else if (running){
mseconds++;
mseconds2++;
 
mseconds50=mseconds;

        if (mseconds2==19) {
         mseconds2 = 0;
            seconds++;
            if (seconds == 60) {
                seconds = 0;
                minutes++;
              }

        }
    }
    ExecuteHandler(oldint5);
}


int op ;


// Virtual Screens
void *light,*dark;


/************* Some  Sprites Declaration ***************/

char wall [8]={0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF};
char dot  [8]={0x00,0x00,0x00,0x18,0x18,0x00,0x00,0x00};
char bdot  [8]={~0x00,~0x00,~0x00,~0x18,~0x18,~0x00,~0x00,~0x00};
char curs [8]={0x00,0x18,0x18,0x7E,0x7E,0x18,0x18,0x00};

char cross[16]={0x00,0x42,0x24,0x18,0x18,0x24,0x42,0x00,0x00,0x24,0x5A,0x24,0x24,0x5A,0x24,0x00};

char start[16]= {0xFF,0x81,0x9F,0xC7,0xE3,0xF9,0x81,0xFF,0x00,0x40,0x20,0x08,0x10,0x04,0x02,0x00 };
char goal [16]= {0xFF,0x83,0x9F,0xBF,0xB9,0x9D,0x81,0xFF,0x00,0x40,0x20,0x00,0x00,0x20,0x40,0x00 };



/**** The Map at the beginning *****************/

char map1 [MAP_Y][MAP_X]=
                  {{3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3},
                   {3,0,3,0,0,0,0,3,0,0,0,0,0,0,0,0,0,0,0,3},
                   {3,0,3,0,0,3,3,3,0,0,3,3,3,0,0,0,0,0,0,3},
                   
                   {3,0,3,0,0,0,0,0,0,3,3,0,0,3,3,3,0,0,0,3},
                   {3,0,3,3,3,3,3,0,0,0,0,0,0,3,0,0,3,0,0,3},
                   {3,0,0,0,0,0,0,0,3,3,3,3,0,3,0,0,0,3,0,3},
                   
                   {3,0,0,0,3,0,0,0,0,0,3,0,0,3,0,0,0,3,0,3},
                   {3,0,0,3,3,3,0,0,0,0,3,0,0,0,0,0,3,0,0,3},
                   {3,0,3,0,0,0,0,0,0,3,3,0,0,0,0,0,3,0,0,3},
                   
                   {3,0,3,0,0,3,0,0,0,0,3,0,0,0,0,0,3,0,0,3},
                   {3,0,0,0,0,3,0,0,0,0,3,0,0,0,0,0,3,0,0,3},
                   {3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3}};

/****************** STRUCTURES *********************/



typedef struct 
{
int x;
int y;
} SQUARE;

// The 'Open' List
typedef struct 
{
SQUARE pos;
SQUARE parent;
int F_cost;
int H_cost;
int G_cost;
} OPEN_DATA;

// The 'Closed' List
typedef struct 
{
SQUARE pos;
SQUARE parent;
} CLOSED_DATA;


typedef struct 
{
SQUARE start;
SQUARE goal;
int h_coef;  // what you put when you launch the program
int cursor_x;  // cursor position
int cursor_y;
char map    [ MAP_Y ] [ MAP_X ] ;  // the current map
char status [ MAP_Y ] [ MAP_X ] ;  // says if a square is in the Close or Open List
OPEN_DATA open     [ MAP_Y  *  MAP_X ] ;  // the Open List
CLOSED_DATA closed   [ MAP_Y  *  MAP_X ] ;// the Closed List

int lower_F;      // will point to the lowerF square in Open ( no use :)
int num_open;     // number of element in the Open List
int num_closed;   // number of element in the Closed List
long int time;    
int current;      
int search_flag;  // search indicator 
int parent_G_cost;// the cost to go from the start to the currenrt square  
int detail;
int search;
OPEN_DATA *temp;  // just for copy
 

}DATA;


/***  Main functions *********/

void init (DATA *pdata);
void add_to_open (DATA *pdata , SQUARE to_add , SQUARE parent  );
int search_open_pos ( DATA *pdata , SQUARE to_search );
int calc_Hcost (DATA *pdata , SQUARE to_add);
int calc_Gcost  (DATA *pdata , SQUARE to_add , SQUARE parent);
void A_star ( DATA *pdata );




// Compare two squares
int cmp_sqr ( SQUARE sq1 , SQUARE sq2 )
{
return ( sq1.x==sq2.x && sq1.y==sq2.y );
}




// Init all the Data 
void init (DATA *pdata)
{
// Clear all the lists
memset ( pdata->status , UNCHECKED ,  MAP_Y  *  MAP_X  ) ;
memset (pdata->open , 0 , sizeof (pdata->open ));
memset (pdata->closed , 0 , sizeof (pdata->closed ));

// we are searching
pdata->search_flag = SEARCHING ; 

// No element in the lists
pdata->num_open = 0 ;
pdata->num_closed = 0 ;

pdata->parent_G_cost = 0 ;

// add the start square in the Open list
add_to_open ( pdata , pdata->start ,  pdata->start );
}




/*** Add a Square in the open list *********/


// So that the last element is the one with the lowest F cost

void add_to_open (DATA *pdata , SQUARE to_add , SQUARE parent  )
{
	op ++ ;
	int i,f_cost,h_cost,g_cost;
	
	// if we have to add the goal , the search is over
	if ( cmp_sqr ( to_add , pdata->goal ) )
	pdata->search_flag = PATH_FOUND ;
	
	// if we want to display the squares in the Open List
	if (pdata->detail==0)
	{
	for (i=0;i<70;i++)  // to slow down a bit :)
	GraySprite8_OR (to_add.x * 8,to_add.y * 8, 8 , cross ,cross+8 ,GetPlane(0),GetPlane(1));
	}
	
	// register the new Square and its characteristics in the Open list
	
	g_cost = pdata->parent_G_cost + calc_Gcost (pdata , to_add , parent ); // its G cost
	h_cost = pdata->h_coef * calc_Hcost ( pdata , to_add );  // its H cost
	f_cost = g_cost + h_cost ;
	
	
	// Find the right place of this element in the open list ( according to F_cost )
	for (i=0;i<pdata->num_open;i++)
	{
	 if (pdata->open [ i ] . F_cost < f_cost ) 
	   break;
	}
// two memcpy are faster than one memmove...	
	memcpy(pdata->temp , pdata->open + i ,  sizeof(OPEN_DATA)*(pdata->num_open-i));
	memcpy(pdata->open + (i+1) , pdata->temp, sizeof(OPEN_DATA)*(pdata->num_open-i));
	
//	memmove(pdata->open +  (i+1) , pdata->open + i , sizeof(OPEN_DATA)*(pdata->num_open-i));  
		
	pdata->open [ i ] . pos = to_add ;    // its position
	pdata->open [ i ] . parent = parent ; // its parent 
	pdata->open [ i ] . G_cost = g_cost ;
	pdata->open [ i ] . H_cost = h_cost ;
	// f = g + h 
	pdata->open [ i ] . F_cost = f_cost;
	
	// the square is flagged as 'Open' in the Status MAP 
	pdata->status [ to_add.y ] [ to_add.x ] = OPEN ;
	
	// one more element in Open :)
	(pdata->num_open)++ ;
}



/**** Return the position of a Square in the Open list       ***/

int search_open_pos ( DATA *pdata , SQUARE to_search )
{
int i;

for ( i = 0 ; i < pdata->num_open ; i++ )
 if ( pdata->open[i].pos.x == to_search.x &&  pdata->open[i].pos.y == to_search.y ) 
 return i;

return -1;
} 

/**** Return the position of a Square in the Close list       ***/

int search_closed_pos ( DATA *pdata , SQUARE to_search )
{
int i;

for ( i = 0 ; i < pdata->num_closed ; i++ )
 if ( pdata->closed[i].pos.x == to_search.x &&  pdata->closed[i].pos.y == to_search.y ) 
 return i;

return -1;
} 






/**** Return the Heursistic (H) cost of a square  (manathan method)       ***/

int calc_Hcost (DATA *pdata , SQUARE to_add)
{
return ABS ( pdata->goal.x - to_add.x ) + ABS ( pdata->goal.y - to_add.y )  ;
}




/**** Return the G cost of a square    ***/
// 5 for straight
// 7 for diagonals

int calc_Gcost  (DATA *pdata , SQUARE to_add , SQUARE parent)
{
int cost=0;

if (to_add.x != parent.x )
cost = 5;
if (to_add.y != parent.y )
cost += 5 ;
 
if (cost == 10 ) cost = 7 ; 

// mutiply the cost according to the nature of the square (normal, grass or water )
cost *= (2 + pdata->map[ to_add.y ] [ to_add.x ] );
return cost;
}





/************ The Main Function : A* **************/

void A_star ( DATA *pdata )
{

int dx,dy,check_x,check_y,cur_x,cur_y,new_cost,open_pos;

while ( pdata->search_flag == SEARCHING )
 {
  
  // our current square is the one with the lowest F cost ( last position in Open )
  cur_x = pdata->open [ pdata->num_open - 1 ].pos.x ;
  cur_y = pdata->open [ pdata->num_open - 1 ].pos.y ;
  
  pdata->parent_G_cost = pdata->open [ pdata->num_open - 1 ].G_cost ;     
  pdata->status [ cur_y ] [ cur_x ] = CLOSED ;
  // has been checked CLOSED 
 
  //retire the current square from Open  ( will be erase ) and add it in Close
  (pdata->num_open)--;
  
  pdata->closed [pdata->num_closed].pos    = pdata->open [ pdata->num_open ].pos ;
  pdata->closed [pdata->num_closed].parent = pdata->open [ pdata->num_open ].parent ;
   
  (pdata->num_closed)++  ;
    
 // for the 8 surrounding squares 
  for ( dx = -1 ; dx < 2 ; dx ++ )
  for ( dy = -1 ; dy < 2 ; dy ++ )
  {
 // don't check the current square  	
  	if ( dy == 0 && dx == 0 ) continue ;
  	
 // coordinates of the square we're going to check
  	check_x = cur_x + dx ;
  	check_y = cur_y + dy ;

 // if it's a wall or if has already been checked CLOSED , skip it 	
  	if ( pdata->status [ check_y ] [ check_x ] == CLOSED || pdata->map [ check_y ] [ check_x ] == WALL )
  	continue ;
  	
 // special diagonal tests  	
  	if ((dy!=0&&dx!=0)&&( pdata->map [ cur_y ] [ cur_x + dx ] == WALL ||  pdata->map [ cur_y + dy ] [ cur_x ] == WALL ))
  	continue ;
  	  	  	

 // if it's unchecked , add it to Open  	
  	if (pdata->status [ check_y ] [ check_x ] == UNCHECKED ) 
  	{
    	add_to_open ( pdata , (SQUARE){check_x,check_y}  , (SQUARE){cur_x,cur_y} );
  	}
 // if it's already in in open , special tests : 	
  	else if  (pdata->status [ check_y ] [ check_x ] == OPEN )
        {
           // search the position the 'check' square has in the Open List 
           open_pos = search_open_pos ( pdata , (SQUARE){check_x,check_y} ) ;
           
           // G_cost if we'd take the way from the 'current' square to the 'check' one  
           new_cost = pdata->parent_G_cost +
                      calc_Gcost  (pdata , (SQUARE){cur_x,cur_y} , (SQUARE){check_x,check_y} );
                   
           // if this new_cost G is lower than the previous one the 'check' square had , we'll take the 
           // last way instead , and update the datas : 
           if ( pdata->open [ open_pos ].G_cost > new_cost ) 
             {
              // new G cost
              pdata->open [ open_pos ].G_cost   = new_cost ;
              // its parent is now the current 
              pdata->open [ open_pos ].parent.x = cur_x  ;
              pdata->open [ open_pos ].parent.y = cur_y  ;
              // new F cost 
              pdata->open [ open_pos ].F_cost   = pdata->open [ open_pos ].H_cost + new_cost;
             }
         
         }	
   }//endfor	 
  	
 // if there is no element in Open , there is no path .... 	
  if (pdata->num_open==0)
  pdata->search_flag = NO_PATH;
  
  }

}






/***** Handles Key inputs *******/

int key(DATA *pdata,int k)
{
int i,j,flag=0;

// cursor moves........
if (k==KEY_RIGHT&&pdata->cursor_x < MAX_X )
{
pdata->cursor_x++;
flag=1;
}
if (k==KEY_LEFT&&pdata->cursor_x > MIN_X )
{
pdata->cursor_x--;
flag=1;
}
if (k==KEY_DOWN&&pdata->cursor_y < MAX_Y )
{
pdata->cursor_y++;
flag=1;
}
if (k==KEY_UP&&pdata->cursor_y > MIN_Y )
{
pdata->cursor_y--;
flag=1;
}


// Place a wall square ......
if (k==KEY_F1)
{
pdata->map[pdata->cursor_y][pdata->cursor_x] = 3 ;
flag=1;
}

// Place a road square ......
if (k==KEY_F2)
{
pdata->map[pdata->cursor_y][pdata->cursor_x] = 0 ;
flag=1;
}

// Place a water square ......
if (k==KEY_F3)
{
pdata->map[pdata->cursor_y][pdata->cursor_x] = 2 ;
flag=1;
}

// Place a grass square ......
if (k==KEY_F4)
{
pdata->map[pdata->cursor_y][pdata->cursor_x] = 1 ;
flag=1;
}

// Change the start position ......
if (k==277)
{
pdata->start.x = pdata->cursor_x;
pdata->start.y = pdata->cursor_y;
flag=1;
}

// Open squares are displayed or not...
if (k==KEY_APPS)
pdata->detail = 1 - (pdata->detail);

// Change the goal position ......
if (k==KEY_MODE)
{
flag=1;
pdata->goal.x = pdata->cursor_x;
pdata->goal.y = pdata->cursor_y;
}

// Clear the whole map
if (k==KEY_CLEAR)
{
flag=1;
for (i=1;i<MAP_X-1;i++)
for (j=1;j<MAP_Y-1;j++)
pdata->map[j][i]=0;
}

// start the search...
if (k==KEY_ENTER&&pdata->search==0)
{
pdata->search=1;
flag=1;
}

// start the search , with 50 tests (benchmark) ( STO key)
if (k==258&&pdata->search==0)
{
pdata->search=2;
flag=1;
}

if (flag)
key_time=mseconds50;

if (k==KEY_ESC)
return ESC;

return 1;
}








/*** Once the search is complete , draw the path *********/

void draw_path (DATA *pdata )
{

SQUARE current = pdata->goal ;
int closed_pos = search_open_pos ( pdata , current );
current = pdata->open[ closed_pos ].parent ; 

// Browse the Closed List from parents to parents....
while ( cmp_sqr (current , pdata->start) == 0 )
{
closed_pos = search_closed_pos ( pdata , current ) ;
GraySprite8_OR (current.x * 8,current.y * 8, 8 , dot ,dot ,GetPlane(0),GetPlane(1));
current = pdata->closed[ closed_pos ].parent;
} 

}





/*** redraw the Map *******/

void draw_map (DATA *pdata )
{
int i,j,cell;

ClearGrayScreen2B(light,dark);

for ( i=0 ; i < MAP_Y  ;i++)
for ( j=0 ; j < MAP_X ;j++)
{
	cell = pdata->map [i][j] ;
	if (cell&1)
	Sprite8_OR(j*8,i*8,8,wall,light);
	if (cell&2)
	Sprite8_OR(j*8,i*8,8,wall,dark);
}
GraySprite8_OR(pdata->start.x * 8 , pdata->start.y * 8  , 8 , start+8 , start  , light, dark );
GraySprite8_OR(pdata->goal.x * 8 , pdata->goal.y * 8 , 8 , goal+8 , goal , light, dark );
}






/*Write infos in the file 'a_sav'*/

void write(DATA *pdata)
{

FILE *fp;

unsigned int mag=MAGIC,ver=VERSION;

//Open a file  wb => Write in Binary Mode
EM_moveSymFromExtMem (SYMSTR ("a_sav") ,HS_NULL);

fp = fopen("a_sav","wb");

//Write the 'Magic Number'   (the one in this source is false)
fwrite(&mag,sizeof(mag),1,fp);

//Write the 'Version Number'
fwrite(&ver,sizeof(ver),1,fp);


fwrite(&(pdata->start),sizeof(SQUARE),1,fp);
fwrite(&(pdata->goal),sizeof(SQUARE),1,fp);
fwrite(&(pdata->h_coef),sizeof(int),1,fp);
fwrite(&(pdata->cursor_x),sizeof(int),1,fp);
fwrite(&(pdata->cursor_y),sizeof(int),1,fp);
fwrite(pdata->map,sizeof(char),MAP_X*MAP_Y,fp);

// Put extension
fputc(0,fp);
fputs("HSC",fp);
fputc(0,fp);
fputc(OTH_TAG,fp);
//Close the File
fclose(fp);

}






/*Write infos in the file 'a_sav'*/

void open(DATA *pdata)
{

FILE *fp;

unsigned int mag=MAGIC,ver=VERSION;

fp = fopen("a_sav","rb");

//Write the 'Magic Number'   (the one in this source is false)
fread(&mag,sizeof(mag),1,fp);

//Write the 'Version Number'
fread(&ver,sizeof(ver),1,fp);


fread(&(pdata->start),sizeof(SQUARE),1,fp);
fread(&(pdata->goal),sizeof(SQUARE),1,fp);
fread(&(pdata->h_coef),sizeof(int),1,fp);
fread(&(pdata->cursor_x),sizeof(int),1,fp);
fread(&(pdata->cursor_y),sizeof(int),1,fp);
fread(pdata->map,sizeof(char),MAP_X*MAP_Y,fp);

}








// Main Function
void _main(void)
{

/* Some initialisation ....*/
DATA data;
int i;
data.detail = 1 ;
OSInitKeyInitDelay (80);
OSInitBetweenKeyDelay (16);


FontSetSys(F_4x6);
int k=0;
key_time=0;
data.start.x = 1 ;
data.start.y = 1 ;
data.goal.x  = 18 ;
data.goal.y  = 10 ;
data.cursor_x=1;
data.cursor_y=1;
data.search=0;
data.temp = malloc( 100 * sizeof ( OPEN_DATA) );

//Search for the "a_sav" file  
SYM_ENTRY *SymPtr = DerefSym (SymFind ($(a_sav)));
//if doesn't here,create one...
if (!SymPtr) 
{
  memcpy ( data.map    , map1 ,  MAP_Y  *  MAP_X  ) ;
	write(&data);
}
//Else Open the "a_sav"
else
 open(&data);
 

// read the parameter 'h_coef' 
ESI argptr;
InitArgPtr (argptr);
data.h_coef=GetIntArg(argptr);


GrayOn();
// Create the Virtual screens
light = malloc (3840);
dark  = malloc (3840);

if (light==NULL||dark==NULL)
return;

//initialize data
init (&data);


running = 1 ;
key_time = mseconds50;



// Main Loop, while ESC is not pressed
while ( k!=264 )
{
	draw_map(&data);
	
	// Norma (single) search
	if (!data.search)
	{
  	GraySprite8_XOR (data.cursor_x * 8 ,data.cursor_y * 8 , 8 , curs , curs ,light,dark);
	}
	else
	{
// 50 Tests (Benchmark)				
	if (data.search==2)	
{
// Load the Clock
oldint5 = GetIntVec(AUTO_INT_5);
SetIntVec(AUTO_INT_5, myint5handler);
resettime = 1;   

// Disable AUTO_INT_1 
INT_HANDLER save_int_1 = GetIntVec (AUTO_INT_1);
SetIntVec (AUTO_INT_1, DUMMY_HANDLER); 


		resettime=1;
		running = 1 ;

		op = 0 ;

// 50 tests
		for (i=0 ; i < 50 ; i++ )
		{
			// we press ENTER
			init(&data);
			A_star(&data);
		}

 
//Restore the timers
OSFreeTimer(USER_TIMER);
SetIntVec(AUTO_INT_5, oldint5);
SetIntVec (AUTO_INT_1, save_int_1);
 
 // Display the results :
  printf_xy (10,20,"  nb open  %d   ",op/50);
  printf_xy (10,30,"  tics(*100) %ld ",mseconds50*2);
  ngetchx();		
}
	if (data.search==1)	
{
			// we press ENTER
			init(&data);
			A_star(&data);
}
		
		// Draw the path (if there's one ..)	
			if (data.search_flag == PATH_FOUND )
			draw_path(&data);
				
					do {
					k=ngetchx();
					} while (k!=13);
					
			data.search=0;
	   
	 
	 }

	FastCopyScreen(light,GetPlane(0));
	FastCopyScreen(dark,GetPlane(1));
	
	k=ngetchx();
	key(&data,k);
	
}


// save the map 
write(&data);
free(data.temp);
// some cleaning before exiting...
GrayOff();
free(light);
free(dark);

PortRestore();


}

 









